/*
	rtd.h

*/

#ifndef	MYMATH_H
# include "MyMath.h"
#endif

struct color {
	int	r,
		g,
		b;
};

struct vector {
	FFP	x,
		y,
		z,
		l,
		xzl;
};

struct ray {
	struct	vector	org;
	struct	vector	dir;
};

struct sphere {
	struct	vector	cent;
	FFP	rad;
};

struct ball {
	struct	sphere	s;
	FFP	ior;
	FFP	rfr;
	FFP	rfl;
	FFP	dif;
	FFP	amb;
};

struct mat {
	struct	vector	x;	/*  first !row! */
	struct	vector	y;	/* second !row! */
	struct	vector	z;	/*  third !row! */
};

