/*
	MyMath.h

	Include file to interface to fast floating point routines
*/

#ifndef	MYMATH_H
#define	MYMATH_H

#define	FFP	int
#define	IEEE	float

typedef	union {
	IEEE	ieee;
	FFP	ffp;
} fp;

extern	int	SPFix();
extern	FFP	SPFlt();
extern	int	SPCmp();
extern	int	SPTst();
extern	FFP	SPAbs();
extern	FFP	SPNeg();
extern	FFP	SPAdd();
extern	FFP	SPSub();
extern	FFP	SPMul();
extern	FFP	SPDiv();

extern	FFP	SPAtan();
extern	FFP	SPSin();
extern	FFP	SPCos();
extern	FFP	SPTan();
extern	FFP	SPSincos();
extern	FFP	SPSinh();
extern	FFP	SPCosh();
extern	FFP	SPTanh();
extern	FFP	SPExp();
extern	FFP	SPLog();
extern	FFP	SPPow();
extern	FFP	SPSqrt();
extern	int	SPTieee();
extern	FFP	SPFieee();


#ifndef	DONT_BARK_MATH			/* don't ask ... */

extern	int	open_math();
extern	void	close_math();
extern	IEEE	ffp_to_ieee();
extern	FFP	ieee_to_ffp();

#endif

#endif
