#include <stdio.h>
#include "MyMath.h"
#include "rtd.h"
#include "extern.h"

g_bal (df)/* gets data for the balls, returns number of balls */
FILE * df;
{
    int     i;
    float   x,
            y,
            z,
            r,
            ior,
            rfr,
            rfl,
            dif,
            amb;

	for (
		i = 0;
		fscanf (df, "%f %f %f %f %f %f %f %f %f\n",
			&x, &y, &z, &r, &ior, &rfr, &rfl, &dif, &amb) != EOF;
		i++
	) {
/*
		printf("%d : %f %f %f %f %f %f %f %f %f\n",
			i, x, y, z, r, ior, rfr, rfl, dif, amb
		);
*/
		/* get some space for the ball */
		bl[i] = (struct ball *) malloc (sizeof (struct ball));
		bl[i] -> s.cent.x = ieee_to_ffp(x);
		bl[i] -> s.cent.y = ieee_to_ffp(y);
		bl[i] -> s.cent.z = ieee_to_ffp(z);
		bl[i] -> s.rad = ieee_to_ffp(r);
		bl[i] -> ior = ieee_to_ffp(ior);
		bl[i] -> rfr = ieee_to_ffp(rfr);
		bl[i] -> rfl = ieee_to_ffp(rfl);
		bl[i] -> dif = ieee_to_ffp(dif);
		bl[i] -> amb = ieee_to_ffp(amb);
	}
	return (i);
}

